package widebase.stream.codec.rq

import org.jboss.netty.buffer. { ChannelBuffer, ChannelBuffers }
import org.jboss.netty.channel.Channel
import org.jboss.netty.channel.ChannelHandlerContext

import widebase.stream.codec. { MessageTypeEncoder, RequestEncoder }

/** Encode consumer message.
 *
 * @author myst3r10n
 */
class ConsumerEncoder extends RequestEncoder with MessageTypeEncoder {

  @throws(classOf[Exception])
  override def encode(
    ctx: ChannelHandlerContext,
    channel: Channel,
    msg: Object): Object = writeMessage(ChannelBuffers.dynamicBuffer, msg)

  override protected def writeMessage(buffer: ChannelBuffer, message: Object): Object = {

    message match {

      case message: SubscribeMessage =>
        writeId(buffer, MessageType.SubscribeMessage.id)
        writeString(buffer, message.name)
        writeString(buffer, message.selector)

      case message => return super.writeMessage(buffer, message)

    }

    finish(buffer)

    buffer

  }
}

