package widebase.stream.codec.rq

import org.jboss.netty.buffer. { ChannelBuffer, ChannelBuffers }
import org.jboss.netty.channel.Channel
import org.jboss.netty.channel.ChannelHandlerContext

import widebase.stream.codec. { MessageTypeEncoder, RequestEncoder }

/** Encode producer message.
 *
 * @author myst3r10n
 */
class ProducerEncoder extends RequestEncoder with MessageTypeEncoder {

  @throws(classOf[Exception])
  override def encode(
    ctx: ChannelHandlerContext,
    channel: Channel,
    msg: Object): Object = writeMessage(ChannelBuffers.dynamicBuffer, msg)

  override protected def writeMessage(buffer: ChannelBuffer, message: Object): Object = {

    message match {

      case message: PublishMessage =>
        writeId(buffer, MessageType.PublishMessage.id)
        writeString(buffer, message.name)
        buffer.writeInt(message.bytes.length)
        buffer.writeBytes(message.bytes)

      case message => return super.writeMessage(buffer, message)

    }

    finish(buffer)

    buffer

  }
}

